<?php

namespace App\Http\Middleware;

use App\Model\Depart;
use App\Service\EmployeeService;
use Closure;
use App\Service\TokenService;

/**
 * 用户登陆中间件
 */
class CheckLogin
{
    /**
     * Handle an incoming request.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \Closure  $next
     * @return mixed
     */
    public function handle($request, Closure $next)
    {
        $token=$request->header('Authorization');
        if (!isset($token)){
            return  response()->json(['code'=>1,'msg'=>'缺少token','data'=>null]);
        }

        //校验token
        $result = TokenService::verifyToken($token);
        if ($result <= 0){
            return response()->json(['code'=>1,'msg'=>TokenService::error[$result],'data'=>null]);
        }

        //校验用户
        $checkResult = EmployeeService::checkUser($result);
        list($state, $data) = $checkResult;
        if(! $state) return response()->json(['code'=>1,'msg'=>$data,'data'=>null]);

        //人员角色
        $data['role'] = EmployeeService::getPersonRole($result);
        $return = EmployeeService::getLoginDepart($result);
        //所属部门
        $data['rule_depart'] = $return[0] ?? [];
        //顶级部门
        $data['depart_top'] = $return[1] ?? [];
        //部门对应的顶级部门
        $data['depart_map'] = $return[2] ?? [];
        //权限范围内的部门
        $data['depart_range'] = $return[3] ?? [];
        //是否有所有的部门 （就是 是否总公司）
        $data['is_all_depart'] = $return[4] ?? 0;

        //写入user信息
        $request->userData = $data;

        return $next($request);
    }
}
