<?php

namespace App\Model;

use App\Scopes\DepartmentScope;
use Illuminate\Database\Eloquent\Model;

class PurchaseOrder extends Model
{
//    protected $fillable = ['userData'];
    protected $guarded = [];
    protected $table = "purchase_order"; //指定表
    const CREATED_AT = 'crt_time';
    const UPDATED_AT = 'upd_time';
    protected $dateFormat = 'U';
    const STATE_ZERO = 0;//未确认
    const STATE_ONE = 1;//已确认
    const prefix = 'CG';
    public static $name = [
        self::STATE_ZERO => '未确认',
        self::STATE_ONE => '已确认',
    ];

    const Order_type_one = 1;//普通采购
    const Order_type_two = 2;//代发采购
    const Order_type_three = 3;//采购施工（安装费）

    public static $order_type = [
        self::Order_type_one => '普通采购',
        self::Order_type_two => '代发采购',
        self::Order_type_three => '采购施工（安装费）'
    ];

    public static $user = [];
    public static $search = [];
    public static $is_search = false;

    public function __construct(array $attributes = [])
    {
        if(! empty($attributes['userData'])) {
            self::$user = $attributes['userData'];
            self::$search = $attributes['search'] ?? [];
            self::$is_search = true;
        }
        parent::__construct($attributes);
    }

    protected static function boot(){
        parent::boot();
        if(self::$is_search){
            static::addGlobalScope(new DepartmentScope(self::$user, self::$search));
        }
    }
}
